SystemOrganization addCategory: #'Grease-Slime'!

RBTransformationRule subclass: #GRSlimeTransformationRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

GRSlimeTransformationRule subclass: #GRAnsiBooleansRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiBooleansRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:37'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiBooleansRule methodsFor: 'initialization' stamp: 'lr 2/24/2009 15:27'!
initialize
	super initialize.
	self rewriteRule
		replace: '``@expr1 and: [ | `@temp2 | ``@expr2 ] and: [ | `@temp3 | ``@expr3 ]'
			with: '``@expr1 and: [ | `@temp2 | ``@expr2 and: [ | `@temp3 | ``@expr3 ] ]';
		replace: '``@expr1 and: [ | `@temp2 | ``@expr2 ] and: [ | `@temp3 | ``@expr3 ] and: [ | `@temp4 | ``@expr4 ]'
			with: '``@expr1 and: [ | `@temp2 | ``@expr2 and: [ | `@temp3 | ``@expr3 and: [ | `@temp4 | ``@expr4 ] ] ]';
		replace: '``@expr1 and: [ | `@temp2 | ``@expr2 ] and: [ | `@temp3 | ``@expr3 ] and: [ | `@temp4 | ``@expr4 ] and: [  | `@temp5 | ``@expr5 ]'
			with: '``@expr1 and: [ | `@temp2 | ``@expr2 and: [ | `@temp3 | ``@expr3 and: [ | `@temp4 | ``@expr4 and: [ | `@temp5 | ``@expr5 ] ] ] ]';
		replace: '``@expr1 or: [ | `@temp2 | ``@expr2 ] or: [ | `@temp3 | ``@expr3 ]'
			with: '``@expr1 or: [ | `@temp2 | ``@expr2 or: [ | `@temp3 | ``@expr3 ] ]';
		replace: '``@expr1 or: [ | `@temp2 | ``@expr2 ] or: [ | `@temp3 | ``@expr3 ] or: [ | `@temp4 | ``@expr4 ]'
			with: '``@expr1 or: [ | `@temp2 | ``@expr2 or: [ | `@temp3 | ``@expr3 or: [ | `@temp4 | ``@expr4 ] ] ]';
		replace: '``@expr1 or: [ | `@temp2 | ``@expr2 ] or: [ | `@temp3 | ``@expr3 ] or: [ | `@temp4 | ``@expr4 ] or: [ | `@temp5 | ``@expr5 ]'
			with: '``@expr1 or: [ | `@temp2 | ``@expr2 or: [ | `@temp3 | ``@expr3 or: [ | `@temp4 | ``@expr4 or: [ | `@temp5 | ``@expr5 ] ] ] ]';
		replace: '``@expr1 or: [ | `@temp2 | ``@expr2 ] or: [ | `@temp3 | ``@expr3 ] or: [ | `@temp4 | ``@expr4 ] or: [ | `@temp5 | ``@expr5 ] or: [ | `@temp6 | ``@expr6 ]'
			with: '``@expr1 or: [ | `@temp2 | ``@expr2 or: [ | `@temp3 | ``@expr3 or: [ | `@temp4 | ``@expr4 or: [ | `@temp5 | ``@expr5 or: [ | `@temp6 | ``@expr6 ] ] ] ] ]'! !

!GRAnsiBooleansRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:37'!
name
	^ 'Booleans'! !

!GRAnsiBooleansRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ '#and:and: and #or:or: are not ANSI compatible.'! !

GRSlimeTransformationRule subclass: #GRAnsiCharactersRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiCharactersRule methodsFor: 'accessing' stamp: 'lr 7/16/2009 08:35'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiCharactersRule methodsFor: 'initialization' stamp: 'lr 1/25/2010 22:07'!
initialize
	super initialize.
	self rewriteRule
		replace: 'Character value: ``@expr' with: 'Character codePoint: ``@expr';
		replace: '`#source to: `#target' 
			withValueFrom: [ :node |
				RBLiteralNode value: (String streamContents: [ :stream |
					node receiver value codePoint to: node arguments first value codePoint do: [ :code |
						stream nextPut: (Character codePoint: code) ] ]) ]
			when: [ :node | 
				node receiver value isCharacter
					and: [ node arguments first value isCharacter ] ] ! !

!GRAnsiCharactersRule methodsFor: 'accessing' stamp: 'lr 7/16/2009 08:35'!
name
	^ 'Characters'! !

!GRAnsiCharactersRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ 'Character value: 64 and $a to: $b is not ANSI compatible.'! !

GRSlimeTransformationRule subclass: #GRAnsiCollectionsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiCollectionsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:37'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiCollectionsRule methodsFor: 'initialization' stamp: 'jok 4/23/2010 08:34'!
initialize
	super initialize.
	self rewriteRule
		replace: '``@collection withIndexDo: [ :`each :`index |  | `@temps | ``@.body ]'
			with: '``@collection keysAndValuesDo: [ :`index :`each |  | `@temps | ``@.body ]';
		replace: '``@collection doWithIndex: [ :`each :`index |  | `@temps | ``@.body ]'
			with: '``@collection keysAndValuesDo: [ :`index :`each |  | `@temps | ``@.body ]';
		replace: '``@collection collect: ``@block1 thenDo: ``@block2'
			with: '(``@collection collect: ``@block1) do: ``@block2';
		replace: '``@collection collect: ``@block1 thenSelect: ``@block2'
			with: '(``@collection collect: ``@block1) select: ``@block2';
		replace: '``@collection pairsDo: [ :`t1 :`t2 | ``@.statements ]'
			with: '1 to: ``@collection size by: 2 do:  [ :index | | `t1 `t2 | `t1 := ``@collection at: index. `t2 := ``@collection at: index + 1. ``@.statements ]';
		replace: '``@collection reject: ``@block1 thenDo: ``@block2'
			with: '(``@collection reject: ``@block1) do: ``@block2';
		replace: '``@collection select: ``@block1 thenCollect: ``@block2'
			with: '(``@collection select: ``@block1) collect: ``@block2';
		replace: '``@collection select: ``@block1 thenDo: ``@block2'
			with: '(``@collection select: ``@block1) do: ``@block2';
		replace: '``@collection detectSum: [ :`t1 | ``@.statements. `.last ]'
			with: '``@collection inject: 0 into: [ :sum :`t1 | ``@.statements. sum + (`.last) ]';
		replace: '``@collection valuesDo: ``@block'
			with: '``@collection do: ``@block';
		replace: '``@collection reversed'
			with: '``@collection reverse';	
		replace: '``@dictionary keysSortedSafely'
			with: '``@dictionary keys asSortedCollection';
		replace: '``@collectionClass new: ``@size withAll: ``@character'
			with: '(``@collectionClass new: ``@size) atAllPut: ``@character'! !

!GRAnsiCollectionsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:37'!
name
	^ 'Collections'! !

!GRAnsiCollectionsRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 09:41'!
rationale
	^ 'Some collection methods are not ANSI compatible: #pairsDo:, #collect:thenDo:, #reject:thenDo:, #detectSum:, #valuesDo:, #keysSortedSafely, #new:withAll:, etc.'! !

GRSlimeTransformationRule subclass: #GRAnsiConditionalsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiConditionalsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:36'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiConditionalsRule methodsFor: 'initialization' stamp: 'lr 2/28/2009 21:38'!
initialize
	super initialize.
	self rewriteRule
		replace: '``@boolean ifNotNilDo: ``@block'
			with: '``@boolean ifNotNil: ``@block';
		replace: '``@boolean ifNotNilDo: ``@block1 ifNil: ``@block2'
			with: '``@boolean ifNotNil: ``@block1 ifNil: ``@block2';
		replace: '``@boolean ifNil: ``@block1 ifNotNilDo: ``@block2'
			with: '``@boolean ifNil: ``@block1 ifNotNil: ``@block2';
		replace: '``@boolean ifNotNil: [ | `@temps | ``@.body ]'
			with: '``@boolean ifNotNil: [ :arg | | `@temps | ``@.body ]';
		replace: '``@boolean ifNotNil: [ | `@temps | ``@.body ] ifNil: ``@block '
			with: '``@boolean ifNotNil: [ :arg | | `@temps | ``@.body ] ifNil: ``@block';
		replace: '``@boolean ifNil: ``@block ifNotNil: [ | `@temps | ``@.body ]'
			with: '``@boolean ifNil: ``@block ifNotNil: [ :arg | | `@temps | ``@.body ]'! !

!GRAnsiConditionalsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:37'!
name
	^ 'Conditionals'! !

!GRAnsiConditionalsRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ 'Conditionals like #ifNotNilDo: are not ANSI compatible.'! !

GRSlimeTransformationRule subclass: #GRAnsiConvertorRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiConvertorRule methodsFor: 'accessing' stamp: 'lr 4/14/2009 00:32'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiConvertorRule methodsFor: 'initialization' stamp: 'jf 12/8/2009 23:17'!
initialize
	super initialize.
	self rewriteRule
		replace: '``@object asString' with: '``@object greaseString';
		replace: '``@object asInteger' with: '``@object greaseInteger'! !

!GRAnsiConvertorRule methodsFor: 'accessing' stamp: 'lr 4/14/2009 00:33'!
name
	^ 'Convertors'! !

!GRAnsiConvertorRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ 'The ANSI standard does not support #asInteger and #asString on Object.'! !

GRSlimeTransformationRule subclass: #GRAnsiExceptionsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiExceptionsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:36'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiExceptionsRule methodsFor: 'initialization' stamp: 'lr 2/28/2009 21:44'!
initialize
	super initialize.
	self rewriteRule
		replace: '``@block on: `class do: [ | `@temps | ``@.body ]'
			with: '``@block on: `class do: [ :err | | `@temps | ``@.body ]'! !

!GRAnsiExceptionsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:37'!
name
	^ 'Exceptions'! !

!GRAnsiExceptionsRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ 'Exception handlers expect exactly one argument in ANSI.'! !

GRSlimeTransformationRule subclass: #GRAnsiStreamsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiStreamsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:36'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiStreamsRule methodsFor: 'initialization' stamp: 'lr 2/24/2009 15:29'!
initialize
	super initialize.
	self rewriteRule
		replace: '`{ :node :context | node isVariable and: [ (Smalltalk includesKey: node name asSymbol) not and: [ context at: ''`receiver'' ifAbsentPut: [ node ]. true ] ] } cr'
			with: '`{ :context | context at: ''`receiver'' } nextPut: Character cr';
		replace: '`{ :node :context | node isVariable and: [ (Smalltalk includesKey: node name asSymbol) not and: [ context at: ''`receiver'' ifAbsentPut: [ node ]. true ] ] } lf'
			with: '`{ :context | context at: ''`receiver'' } nextPut: Character lf';
		replace: '``@stream nextPut: Character cr; nextPut: Character lf'
			with: '``@stream crlf';
		replace: '``@collection writeStream'
			with: 'WriteStream on: ``@collection'! !

!GRAnsiStreamsRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:52'!
name
	^ 'Streams'! !

!GRAnsiStreamsRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ '#cr and #lf are not part of the ANSI stream protocol.'! !

GRSlimeTransformationRule subclass: #GRAnsiStringsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRAnsiStringsRule methodsFor: 'accessing' stamp: 'jf 12/29/2009 19:44'!
group
	^ 'ANSI Compatibility'! !

!GRAnsiStringsRule methodsFor: 'initialization' stamp: 'lr 10/14/2010 09:18'!
initialize
	super initialize.
	self rewriteRule
		replace: 'String tab' with: '(String with: Character tab)';
		replace: 'String cr' with: '(String with: Character cr)';
		replace: 'String lf' with: '(String with: Character lf)';
		replace: 'String crlf' with: '(String with: Character cr with: Character lf)';
		replace: 'String space' with: '(String with: Character space)';
		replace: '``@string findTokens: ``@arg' withValueFrom: [ :node |
			| argument |
			argument := node arguments first.
			argument isLiteral ifTrue: [ 
				argument value isArray
					ifTrue: [ argument replaceWith: (RBLiteralNode value: (String withAll: argument value)) ].
				argument value isCharacter
					ifTrue: [ argument replaceWith: (RBLiteralNode value: (String with: argument value)) ] ].
			node
				selector: #subStrings:;
				yourself ]! !

!GRAnsiStringsRule methodsFor: 'accessing' stamp: 'jf 12/29/2009 19:44'!
name
	^ 'Strings'! !

!GRAnsiStringsRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ '#cr, #crlf, #lf, #space, #tab, #findTokens:, ... are not part of the ANSI string protocol.'! !

GRSlimeTransformationRule subclass: #GRNotPortableCollectionsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRNotPortableCollectionsRule methodsFor: 'accessing' stamp: 'jok 3/24/2010 12:56'!
group
	^ 'Grease Portability'! !

!GRNotPortableCollectionsRule methodsFor: 'initialization' stamp: 'jok 3/24/2010 14:52'!
initialize
	super initialize.
	self rewriteRule
		replace: '`@collection beginsWith: `@subCollection'
			with: '`@collection beginsWithSubCollection: `@subCollection';
		replace: '`@collection endsWith: `@subCollection'
			with: '`@collection endsWithSubCollection: `@subCollection'! !

!GRNotPortableCollectionsRule methodsFor: 'accessing' stamp: 'jok 3/24/2010 12:57'!
name
	^ 'Collections'! !

!GRNotPortableCollectionsRule methodsFor: 'accessing' stamp: 'jok 3/24/2010 14:33'!
rationale
	^ '#beginsWith: and #endsWith: are not portable.'! !

GRSlimeTransformationRule subclass: #GRObjectInRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRObjectInRule commentStamp: 'pmm 9/12/2009 10:37' prior: 0!
I detect senders of Object >> #in:
!

!GRObjectInRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:55'!
group
	^ 'Grease Portability'! !

!GRObjectInRule methodsFor: 'initialization' stamp: 'lr 1/25/2010 22:07'!
initialize
	super initialize.
	self rewriteRule
		replace: '``@object in: [ :`var | | `@temps | `@.statements ]'
		with: '[ :`var | | `@temps | `@.statements ] value: ``@object'! !

!GRObjectInRule methodsFor: 'accessing' stamp: 'lr 9/12/2009 11:09'!
name
	^ 'Object>>#in:'! !

!GRObjectInRule methodsFor: 'accessing' stamp: 'lr 9/12/2009 11:09'!
rationale
	^ 'Object>>#in: has different semantics on different Smalltalk dialects.'! !

!GRSlimeTransformationRule class methodsFor: 'testing' stamp: 'jok 1/26/2010 14:36'!
isVisible
	^ self name ~= #GRSlimeTransformationRule! !

RBParseTreeLintRule subclass: #GRSlimeParseTreeLintRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRSlimeParseTreeLintRule class methodsFor: 'testing' stamp: 'jok 1/26/2010 14:32'!
isVisible
	^ self name ~= #GRSlimeParseTreeLintRule! !

GRSlimeParseTreeLintRule subclass: #GRUsesClassForHashRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRUsesClassForHashRule methodsFor: 'running' stamp: 'lr 10/14/2010 09:08'!
checkMethod: aContext
	aContext parseTree selector = #hash
		ifTrue: [ super checkMethod: aContext ]! !

!GRUsesClassForHashRule methodsFor: 'accessing' stamp: 'lr 10/14/2010 09:04'!
group
	^ 'Grease Portability'! !

!GRUsesClassForHashRule methodsFor: 'initialization' stamp: 'lr 10/14/2010 09:07'!
initialize
	super initialize.
	self matcher
		matches: '`@receiver class hash'
		do: [ :node :answer | answer isNil ifTrue: [ node ] ifFalse: [ answer ] ]! !

!GRUsesClassForHashRule methodsFor: 'accessing' stamp: 'lr 10/14/2010 09:05'!
name
	^ 'Uses its class for hash'! !

!GRUsesClassForHashRule methodsFor: 'accessing' stamp: 'lr 10/14/2010 09:06'!
rationale
	^ 'The hash of an object should not depend on the hash of its class as some Smalltalk have non-constant class hashes.'! !

GRSlimeParseTreeLintRule subclass: #GRUsesCurlyBraceArraysRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRUsesCurlyBraceArraysRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:33'!
group
	^ 'Grease Portability'! !

!GRUsesCurlyBraceArraysRule methodsFor: 'initialization' stamp: 'lr 1/25/2010 22:07'!
initialize
	super initialize.
	self matcher
		matches: '{ `@.stmts }'
		do: [ :node :answer | answer isNil ifTrue: [ node ] ifFalse: [ answer ] ]! !

!GRUsesCurlyBraceArraysRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
name
	^ 'Uses curly brace arrays'! !

!GRUsesCurlyBraceArraysRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
rationale
	^ 'Curly brace expressions are not portable accross different Smalltalk dialects.'! !

GRSlimeParseTreeLintRule subclass: #GRUsesLiteralByteArraysRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRUsesLiteralByteArraysRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 15:58'!
group
	^ 'Grease Portability'! !

!GRUsesLiteralByteArraysRule methodsFor: 'initialization' stamp: 'lr 1/25/2010 22:07'!
initialize
	super initialize.
	self matcher
		matches: '`#literal `{ :node | node isLiteralArray and: [ node isForByteArray ] }'
		do: [ :node :answer | answer isNil ifTrue: [ node ] ifFalse: [ answer ] ]! !

!GRUsesLiteralByteArraysRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
name
	^ 'Uses literal byte arrays'! !

!GRUsesLiteralByteArraysRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
rationale
	^ 'Literal byte arrays are not portable accross different Smalltalk dialects.'! !

!ParseTreeEnvironment methodsFor: '*grease-slime' stamp: 'lr 11/2/2009 20:20'!
matcher
	^ matcher ifNil: [ matcher := RBParseTreeSearcher new ]! !

!GRPackage class methodsFor: '*grease-slime' stamp: 'lr 2/17/2010 15:22'!
greaseSlime
	^ self new
		name: 'Grease-Slime';
		description: 'Code critis for Grease. Detects common types of bugs and non-portable code.';
		addDependency: 'Grease-Core';
		url: #seasideUrl;
		yourself! !

RBBlockLintRule subclass: #GRSlimeBlockLintRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

GRSlimeBlockLintRule subclass: #GRBasicNewInitializeMissingRule
	instanceVariableNames: 'matcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRBasicNewInitializeMissingRule methodsFor: 'running' stamp: 'jf 12/16/2009 13:59'!
checkClass: aContext 
	(aContext selectedClass isMeta not and: 
		[ (aContext selectedClass includesSelector: #initialize) and: 
			[ (aContext selectedClass includesBehavior: GRObject) not and: 
				[ (aContext selectedClass includesBehavior: GRNotification) not and: 
					[ (aContext selectedClass includesBehavior: GRError) not and: 
						[ aContext selectedClass class methodDictionary noneSatisfy: 
							[ :each | 
							matcher 
								executeTree: each parseTree
								initialAnswer: false ] ] ] ] ] ]) ifTrue: 
		[ result 
			addClass: aContext selectedClass
			selector: #initialize ]! !

!GRBasicNewInitializeMissingRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:20'!
group
	^ 'Grease Portability'! !

!GRBasicNewInitializeMissingRule methodsFor: 'initialization' stamp: 'lr 11/2/2009 20:09'!
initialize
	super initialize.
	matcher := RBParseTreeSearcher new.
	matcher 
		matches: 'self basicNew initialize'
		do: [ :node :answer | true ]! !

!GRBasicNewInitializeMissingRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
name
	^ '#basicNew initialize is missing'! !

!GRBasicNewInitializeMissingRule methodsFor: 'accessing' stamp: 'lr 1/25/2010 22:07'!
rationale
	^ '#initialize is not called implicitely when sending #new to an object in other Smalltalk dialects. Consider subclassing GRObject.'! !

GRSlimeBlockLintRule subclass: #GRDeprecatedApiProtocolRule
	instanceVariableNames: 'matcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRDeprecatedApiProtocolRule methodsFor: 'running' stamp: 'jok 3/22/2010 12:03'!
checkMethod: aContext
	| matches |
	matches := matcher
		executeTree: aContext parseTree
		initialAnswer: OrderedCollection new.
	matches do: [ :node |
		" This ensures that the description is of the form ClassName>>#selector:"
		(node arguments first isLiteral and: [ node arguments first value isString and: [ aContext selectedClass name greaseString , '>>#' , aContext selector greaseString ~= node arguments first value ] ]) ifTrue: [
			result addClass: aContext selectedClass selector: aContext selector.
			result addSearchString: node arguments first value ].
		" This ensures that the description is a string and ends with a dot."
		(node arguments size > 1 and: [ node arguments second isLiteral and: [ node arguments second value isString and: [ (node arguments second value endsWithSubCollection: '.') not ] ] ]) ifTrue: [
			result addClass: aContext selectedClass selector: aContext selector.
			result addSearchString: node arguments second value ] ]! !

!GRDeprecatedApiProtocolRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:23'!
group
	^ 'Grease'! !

!GRDeprecatedApiProtocolRule methodsFor: 'initialization' stamp: 'lr 11/2/2009 20:09'!
initialize
	super initialize.
	matcher := RBParseTreeSearcher new.
	matcher 
		matchesAnyOf: #(
			'``@receiver greaseDeprecatedApi: ``@arg1'
			'``@receiver greaseDeprecatedApi: ``@arg1 details: ``@arg2' )
		do: [ :node :answer | answer add: node; yourself ]! !

!GRDeprecatedApiProtocolRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
name
	^ 'Invalid use of deprecated API protocol.'! !

!GRDeprecatedApiProtocolRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:24'!
rationale
	^ 'Make sure to follow the following pattern: self greaseDeprecatedApi: ''Class>>#selector'' details: ''Some description''.'! !

GRSlimeBlockLintRule subclass: #GREmptyStatementsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GREmptyStatementsRule methodsFor: 'running' stamp: 'lr 1/25/2010 22:07'!
checkMethod: aContext 
	| periods position |
	aContext parseTree nodesDo: [ :node |
		node isSequence ifTrue: [
			periods := OrderedCollection withAll: node periods.
			1 to: node statements size - 1 do: [ :index |
				position := periods removeFirst.
				((node statements at: index) stop < position and: [ position < (node statements at: index + 1) start ])
					ifFalse: [ ^ result addClass: aContext selectedClass selector: aContext selector ] ].
			(periods isEmpty or: [ periods size = 1 and: [ node statements notEmpty and: [ node statements last stop < periods first ] ] ])
				ifFalse: [ ^ result addClass: aContext selectedClass selector: aContext selector ] ] ]! !

!GREmptyStatementsRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:25'!
group
	^ 'Grease Portability'! !

!GREmptyStatementsRule methodsFor: 'accessing' stamp: 'lr 9/8/2009 13:59'!
name
	^ 'Empty Statements'! !

!GREmptyStatementsRule methodsFor: 'accessing' stamp: 'lr 9/8/2009 14:12'!
rationale
	^ 'Empty statements are not supported by most Smalltalk implementations.'! !

!GREmptyStatementsRule methodsFor: 'running' stamp: 'lr 9/8/2009 19:15'!
resetResult
	super resetResult.
	result addSearchString: '..'; addSearchString: '.'! !

GRSlimeBlockLintRule subclass: #GRInvalidObjectInitializationRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRInvalidObjectInitializationRule methodsFor: 'running' stamp: 'jok 3/22/2010 11:51'!
checkMethod: aContext 
	(aContext selectedClass isMeta not 
		and: [ (aContext selector beginsWithSubCollection: #initialize) 
		and: [ aContext selector numArgs > 0
		and: [ aContext selectedClass ~= GRObject
		and: [ (aContext selectedClass includesBehavior: GRObject)
		and: [ (aContext superMessages includes: aContext selector) not 
		and: [ aContext selfMessages noneSatisfy: [ :each | each beginsWithSubCollection: #initialize ] ] ] ] ] ] ]) 
			ifTrue: [ result addClass: aContext selectedClass selector: aContext selector ]! !

!GRInvalidObjectInitializationRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:27'!
group
	^ 'Grease Portability'! !

!GRInvalidObjectInitializationRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
name
	^ 'Invalid object initialization'! !

!GRInvalidObjectInitializationRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
rationale
	^ 'Initialize methods are required to call the designated initializer or its super implementation.'! !

GRSlimeBlockLintRule subclass: #GRNonPortableSourceFormatRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRNonPortableSourceFormatRule methodsFor: 'running' stamp: 'lr 11/8/2010 22:47'!
checkMethod: aContext 
	(aContext sourceCode asString isKindOf: ByteString)
		ifFalse: [ result addClass: aContext selectedClass selector: aContext selector ]! !

!GRNonPortableSourceFormatRule methodsFor: 'accessing' stamp: 'lr 11/8/2010 22:45'!
group
	^ 'Grease Portability'! !

!GRNonPortableSourceFormatRule methodsFor: 'accessing' stamp: 'lr 11/8/2010 22:45'!
name
	^ 'Non portable source format'! !

!GRNonPortableSourceFormatRule methodsFor: 'accessing' stamp: 'lr 11/8/2010 22:48'!
rationale
	^ 'The method source is required to be a plain string, for portability reasons a wide-string is not supported.'! !

!GRSlimeBlockLintRule class methodsFor: 'testing' stamp: 'jok 1/26/2010 14:32'!
isVisible
	^ self name ~= #GRSlimeBlockLintRule! !

GRSlimeBlockLintRule subclass: #GRUsesMethodAnnotationsRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRUsesMethodAnnotationsRule methodsFor: 'running' stamp: 'lr 2/27/2009 21:51'!
checkMethod: aContext 
	aContext compiledMethod pragmas do: [ :each |
		result 
			addClass: aContext selectedClass
			selector: aContext selector.
		result addSearchString: each keyword ]! !

!GRUsesMethodAnnotationsRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 15:58'!
group
	^ 'Grease Portability'! !

!GRUsesMethodAnnotationsRule methodsFor: 'accessing' stamp: 'lr 2/27/2009 21:49'!
name
	^ 'Uses method annotations'! !

!GRUsesMethodAnnotationsRule methodsFor: 'accessing' stamp: 'lr 2/27/2009 21:52'!
rationale
	^ 'As of now, it is unclear if method-annotations/pragmas are compatible across all supported platforms. Likely this rule will soon be removed.'! !

GRSlimeBlockLintRule subclass: #GRUsesNotPortableClassRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Slime'!

!GRUsesNotPortableClassRule methodsFor: 'running' stamp: 'lr 2/27/2009 22:14'!
checkClass: aContext 
	aContext selectedClass allSuperclassesDo: [ :each |
		(self classNames includes: each name) ifTrue: [
			result addClass: aContext selectedClass.
			result addSearchString: each name ] ]! !

!GRUsesNotPortableClassRule methodsFor: 'running' stamp: 'jok 1/26/2010 14:18'!
checkMethod: aContext 
	aContext compiledMethod literals do: [ :each | 
		((each isKindOf: Association) and: [ self classNames includes: each key ]) ifTrue: [
			result 
				addClass: aContext selectedClass
				selector: aContext selector.
			result addSearchString: each key ] ]! !

!GRUsesNotPortableClassRule methodsFor: 'private' stamp: 'jf 12/18/2009 14:16'!
classNames
	^ #( Delay MIMEDocument Monitor Mutex MutexSet Random Semaphore TimeStamp Timestamp MessageSend )! !

!GRUsesNotPortableClassRule methodsFor: 'accessing' stamp: 'jok 1/26/2010 14:16'!
group
	^ 'Grease Portability'! !

!GRUsesNotPortableClassRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
name
	^ 'Uses not portable class'! !

!GRUsesNotPortableClassRule methodsFor: 'accessing' stamp: 'lr 2/24/2009 15:35'!
rationale
	^ 'Some classes are not portable accross different Smalltalk dialects.'! !
